/********************************** (C) COPYRIGHT *******************************
* File Name          : USBHOST.C
* Author             : WCH
* Version            : V1.3
* Date               : 2016/06/24 
* Description        :
 USB host example for CH559, start USB device under DP/DM port
 USBӦ,ʼöDP/DM˿ӵUSB豸,ԲU̻߲USB,HID
 ỤҪCH559UFX.LIB/CH559UFI.LIBļϵͳļ
*******************************************************************************/
#define FOR_ROOT_UDISK_ONLY     1   // ֻDP/DM˿ڵUļ(ʹӳCH559UFI/X),򱾳򻹼ʾHID
#include <CH559.H>
#include <stdio.h>
#include <string.h>
#include "../../USB_LIB/CH559UFI.H"
#include "../../USB_LIB/CH559UFI.C"

#pragma  NOAREGS

// ӳ򷵻״̬
#define ERR_SUCCESS         0x00    // ɹ
#define ERR_USB_CONNECT     0x15    /* ⵽USB豸¼,Ѿ */
#define ERR_USB_DISCON      0x16    /* ⵽USB豸Ͽ¼,ѾϿ */
#define ERR_USB_BUF_OVER    0x17    /* USB̫໺ */
#define ERR_USB_DISK_ERR    0x1F    /* USB洢ʧ,ڳʼʱUSB洢֧,ڶдпǴ𻵻ѾϿ */
#define ERR_USB_TRANSFER    0x20    /* NAK/STALLȸ0x20~0x2F */
#define ERR_USB_UNSUPPORT   0xFB
#define ERR_USB_UNKNOWN     0xFE
// ȡ豸
UINT8C  SetupGetDevDescr[] = { USB_REQ_TYP_IN, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_DEVICE, 0x00, 0x00, sizeof( USB_DEV_DESCR ), 0x00 };
// ȡ
UINT8C  SetupGetCfgDescr[] = { USB_REQ_TYP_IN, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_CONFIG, 0x00, 0x00, 0x04, 0x00 };
// USBַ
UINT8C  SetupSetUsbAddr[] = { USB_REQ_TYP_OUT, USB_SET_ADDRESS, USB_DEVICE_ADDR, 0x00, 0x00, 0x00, 0x00, 0x00 };
// USB
UINT8C  SetupSetUsbConfig[] = { USB_REQ_TYP_OUT, USB_SET_CONFIGURATION, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
// ˵STALL
UINT8C  SetupClrEndpStall[] = { USB_REQ_TYP_OUT | USB_REQ_RECIP_ENDP, USB_CLEAR_FEATURE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
UINT8X  UsbDevEndp0Size;             /* USB豸Ķ˵0ߴ */
//USB豸Ϣ,CH559֧2豸
#define ROOT_DEV_DISCONNECT     0
#define ROOT_DEV_CONNECTED      1
#define ROOT_DEV_FAILED         2
#define ROOT_DEV_SUCCESS        3
#if !FOR_ROOT_UDISK_ONLY
#define DEV_TYPE_KEYBOARD   ( USB_DEV_CLASS_HID | 0x20 )
#define DEV_TYPE_MOUSE      ( USB_DEV_CLASS_HID | 0x30 )
struct _RootHubDev
{
    UINT8   DeviceStatus;                    // 豸״̬,0-豸,1-豸δʼ,2-豸ʼöʧ,3-豸ҳʼöٳɹ
//  UINT8   DeviceAddress;                   // 豸USBַ
    UINT8   DeviceSpeed;                     // 0Ϊ,0Ϊȫ
    UINT8   DeviceType;                      // 豸
//  union {
//      struct MOUSE {
//          UINT8   MouseInterruptEndp;      // ж϶˵
//          UINT8   MouseIntEndpTog;         // ж϶˵ͬ־
//          UINT8   MouseIntEndpSize;        // ж϶˵ĳ
//      }
//      struct PRINT {
//      }
//  }
//.....    struct  _Endp_Attr   Endp_Attr[4];//˵,֧4˵
    UINT8   GpVar;                           // ͨñ
} xdata ThisUsbDev;
#endif
#define WAIT_USB_TOUT_200US     200          // ȴUSBжϳʱʱ200uS@Fsys=12MHz
/*
Լ: USB豸ַ(οUSB_DEVICE_ADDR)
ֵַ  豸λ
0x02    Root-HUB0µUSB豸ⲿHUB
0x03    Root-HUB1µUSB豸ⲿHUB
0x1x    Root-HUB0µⲿHUBĶ˿xµUSB豸,xΪ1~n
0x2x    Root-HUB1µⲿHUBĶ˿xµUSB豸,xΪ1~n
*/
UINT8X  RxBuffer[ MAX_PACKET_SIZE ] _at_ 0x0000 ;  // IN, must even address
UINT8X  TxBuffer[ MAX_PACKET_SIZE ] _at_ 0x0040 ;  // OUT, must even address
#define pSetupReq   ((PXUSB_SETUP_REQ)TxBuffer)
bit     FoundNewDev;
#pragma NOAREGS
void    mDelayuS( UINT16 n );                // uSΪλʱ
void    mDelaymS( UINT16 n );                // mSΪλʱ
void    DisableRootHubPort( void );          // رն˿,ʵӲѾԶر,˴ֻһЩṹ״̬
UINT8   AnalyzeRootHub( void );              // ˿״̬,ROOT-HUB˿ڵ豸¼
// ERR_SUCCESSΪû,ERR_USB_CONNECTΪ⵽,ERR_USB_DISCONΪ⵽Ͽ
void    SetHostUsbAddr( UINT8 addr );        // USBǰUSB豸ַ
#if FOR_ROOT_UDISK_ONLY
#define SetUsbSpeed( x )
#else
void    SetUsbSpeed( UINT8 FullSpeed );      // õǰUSBٶ
#endif
UINT8   ResetRootHubPort( void );            // ⵽豸,λ,Ϊö豸׼,ΪĬΪȫ
UINT8   EnableRootHubPort( void );           // ʹܶ˿,ӦbUH_PORT_EN1˿,豸Ͽܵ·ʧ
UINT8   WaitUSB_Interrupt( void );           // ȴUSBж
// CH559,ĿĶ˵ַ/PID,ͬ־,20uSΪλNAKʱ(0,0xFFFF),0ɹ,ʱ/
UINT8   USBHostTransact( UINT8 endp_pid, UINT8 tog, UINT16 timeout );  // endp_pid: 4λtoken_pid, 4λǶ˵ַ
UINT8   HostCtrlTransfer( PUINT8X DataBuf, PUINT8I RetLen );  // ִпƴ,8ֽpSetupReq,DataBufΪѡշ
// Ҫպͷ,ôDataBufָЧڴź,ʵʳɹշܳȷرReqLenָֽڱ
void    CopySetupReqPkg( PUINT8C pReqPkt );  // ƿƴ
UINT8   CtrlGetDeviceDescr( void );          // ȡ豸,TxBuffer
UINT8   CtrlGetConfigDescr( void );          // ȡ,TxBuffer
UINT8   CtrlSetUsbAddress( UINT8 addr );     // USB豸ַ
UINT8   CtrlSetUsbConfig( UINT8 cfg );       // USB豸
UINT8   CtrlClearEndpStall( UINT8 endp );    // ˵STALL
#if !FOR_ROOT_UDISK_ONLY
UINT8   AnalyzeHidIntEndp( PUINT8X buf );    // зHIDж϶˵ĵַ
#endif
UINT8   InitRootDevice( void );              // ʼUSB豸
/* Ϊprintfgetkeyʼ */
void    mInitSTDIO( void );
void    InitUSB_Host( void );                // ʼUSB
//#define   FREQ_SYS    12000000             // ϵͳƵ12MHz
/*******************************************************************************
* Function Name  : mDelayus(UNIT16 n)
* Description    : usʱ
* Input          : UNIT16 n
* Output         : None
* Return         : None
*******************************************************************************/
void    mDelayuS( UINT16 n )                                 // uSΪλʱ
{
    while ( n )                              // total = 12~13 Fsys cycles, 1uS @Fsys=12MHz
    {
        ++ SAFE_MOD;                         // 2 Fsys cycles, for higher Fsys, add operation here
#ifdef  FREQ_SYS
#if     FREQ_SYS >= 14000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 16000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 18000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 20000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 22000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 24000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 26000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 28000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 30000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 32000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 34000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 36000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 38000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 40000000
        ++ SAFE_MOD;
#endif
#endif
        -- n;
    }
}
/*******************************************************************************
* Function Name  : mDelayms(UNIT16 n)
* Description    : msʱ
* Input          : UNIT16 n
* Output         : None
* Return         : None
*******************************************************************************/
void    mDelaymS( UINT16 n )                                 // mSΪλʱ
{
    while ( n )
    {
        mDelayuS( 1000 );
        -- n;
    }
}
/*******************************************************************************
* Function Name  : DisableRootHubPort(void)
* Description    : رHUB˿
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void    DisableRootHubPort( void )                           // رն˿,ʵӲѾԶر,˴ֻһЩṹ״̬
{
    CH559DiskStatus = DISK_DISCONNECT;
#ifndef FOR_ROOT_UDISK_ONLY
    ThisUsbDev.DeviceStatus = ROOT_DEV_DISCONNECT;
//  ThisUsbDev.DeviceAddress = 0x00;
#endif
    UHUB0_CTRL = 0x00;                                       // йHUB0Ŀ,ʵϲҪ
}
/*******************************************************************************
* Function Name  : AnalyzeRootHub(void)
* Description    : ˿״̬,˿ڵ豸¼
                   ˿ڵĲ¼,豸γ,еDisableRootHubPort(),˿ڹر,¼,Ӧ˿ڵ״̬λ
* Input          : None
* Output         : None
* Return         : ERR_SUCCESSΪû,ERR_USB_CONNECTΪ⵽,ERR_USB_DISCONΪ⵽Ͽ
*******************************************************************************/
UINT8   AnalyzeRootHub( void )
{
    UINT8   s;
    s = ERR_SUCCESS;
    if ( USB_HUB_ST & bUHS_H0_ATTACH )                       // 豸
    {
#if FOR_ROOT_UDISK_ONLY
        if ( CH559DiskStatus == DISK_DISCONNECT
#else
        if ( ThisUsbDev.DeviceStatus == ROOT_DEV_DISCONNECT  // ⵽豸
#endif
                || ( UHUB0_CTRL & bUH_PORT_EN ) == 0x00 )    // ⵽豸,δ,˵Ǹղ
        {
            DisableRootHubPort( );                           // رն˿
#if FOR_ROOT_UDISK_ONLY
            CH559DiskStatus = DISK_CONNECT;
#else
//          ThisUsbDev.DeviceSpeed = USB_HUB_ST & bUHS_DM_LEVEL ? 0 : 1;
            ThisUsbDev.DeviceStatus = ROOT_DEV_CONNECTED;    //ӱ־
#endif
            printf( "USB dev in\n" );
            s = ERR_USB_CONNECT;
        }
    }
#if FOR_ROOT_UDISK_ONLY
    else if ( CH559DiskStatus >= DISK_CONNECT )
    {
#else
    else if ( ThisUsbDev.DeviceStatus >= ROOT_DEV_CONNECTED ) //⵽豸γ
    {
#endif
        DisableRootHubPort( );                                // رն˿
        printf( "USB dev out\n" );
        if ( s == ERR_SUCCESS )
        {
            s = ERR_USB_DISCON;
        }
    }
//  UIF_DETECT = 0;                                           // жϱ־
    return( s );
}
/*******************************************************************************
* Function Name  : SetHostUsbAddr
* Description    : USBǰUSB豸ַ
* Input          : UINT8 addr
* Output         : None
* Return         : None
*******************************************************************************/
void  SetHostUsbAddr( UINT8 addr )
{
    USB_DEV_AD = USB_DEV_AD & bUDA_GP_BIT | addr & 0x7F;
}
/*******************************************************************************
* Function Name  : SetUsbSpeed
* Description    : õǰUSBٶ
* Input          : UINT8 FullSpeed
* Output         : None
* Return         : None
*******************************************************************************/
#if !FOR_ROOT_UDISK_ONLY
void    SetUsbSpeed( UINT8 FullSpeed )                          //U̲
{
    if ( FullSpeed )                                            // ȫ
    {
        USB_CTRL &= ~ bUC_LOW_SPEED;                            // ȫ
        UH_SETUP &= ~ bUH_PRE_PID_EN;                           // ֹPRE PID
    }
    else
    {
        USB_CTRL |= bUC_LOW_SPEED;                              // 
    }
}
#endif
/*******************************************************************************
* Function Name  : ResetRootHubPort
* Description    : ⵽豸,λ,Ϊö豸׼,ΪĬΪȫ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8   ResetRootHubPort( void )
{
    UINT16 n = 30000;
	UsbDevEndp0Size = DEFAULT_ENDP0_SIZE;                        //USB豸Ķ˵0ߴ
    SetHostUsbAddr( 0x00 );			
    SetUsbSpeed( 1 );                                            // ĬΪȫ
    UHUB0_CTRL = UHUB0_CTRL & ~ bUH_LOW_SPEED | bUH_BUS_RESET;// ĬΪȫ,ʼλ
    while( n ) 
	{  
		++ SAFE_MOD;  												
		++ SAFE_MOD;
		++ SAFE_MOD;
		++ SAFE_MOD;
		++ SAFE_MOD;
		++ SAFE_MOD;
		++ SAFE_MOD;
		++ SAFE_MOD;
		++ SAFE_MOD;
		if( USB_HUB_ST & ( bUHS_DP_PIN | bUHS_DM_PIN ) )
		{
			UHUB0_CTRL = UHUB0_CTRL & ~bUH_BUS_RESET;  						/* λ */
			return( 0x01 );
		}
		-- n;
	}
    UHUB0_CTRL = UHUB0_CTRL & ~ bUH_BUS_RESET;               // λ
    mDelayuS( 200 );
    UIF_DETECT = 0;											     // жϱ־
	return ( 0x00 );
}
/*******************************************************************************
* Function Name  : EnableRootHubPort
* Description    : ʹܶ˿,ӦbUH_PORT_EN1˿,豸Ͽܵ·ʧ
* Input          : None
* Output         : None
* Return         : ERR_SUCCESSΪ⵽,ERR_USB_DISCONΪ
*******************************************************************************/
UINT8   EnableRootHubPort( void )
{
#if FOR_ROOT_UDISK_ONLY
    if ( CH559DiskStatus < DISK_CONNECT )
    {
        CH559DiskStatus = DISK_CONNECT;
    }
#else
    if ( ThisUsbDev.DeviceStatus < ROOT_DEV_CONNECTED )
    {
        ThisUsbDev.DeviceStatus = ROOT_DEV_CONNECTED;
    }
#endif
    if ( USB_HUB_ST & bUHS_H0_ATTACH )                           // 豸
    {
#if !FOR_ROOT_UDISK_ONLY
        if ( ( UHUB0_CTRL & bUH_PORT_EN ) == 0x00 )              // δʹ
        {
            ThisUsbDev.DeviceSpeed = USB_HUB_ST & bUHS_DM_LEVEL ? 0 : 1;
            if ( ThisUsbDev.DeviceSpeed == 0 )
            {
                UHUB0_CTRL |= bUH_LOW_SPEED;                     // 
            }
        }
#endif
        UHUB0_CTRL |= bUH_PORT_EN;                               //ʹHUB˿
        return( ERR_SUCCESS );
    }
    return( ERR_USB_DISCON );
}
/*******************************************************************************
* Function Name  : WaitUSB_Interrupt
* Description    : ȴUSBж
* Input          : None
* Output         : None
* Return         : ERR_SUCCESS ݽջ߷ͳɹ
                   ERR_USB_UNKNOWN ݽջ߷ʧ
*******************************************************************************/
UINT8   WaitUSB_Interrupt( void )
{
    UINT16  i;
    for ( i = WAIT_USB_TOUT_200US; i != 0 && UIF_TRANSFER == 0; i -- )
    {
        ;
    }
    return( UIF_TRANSFER ? ERR_SUCCESS : ERR_USB_UNKNOWN );
}
/*******************************************************************************
* Function Name  : USBHostTransact
* Description    : CH559,ĿĶ˵ַ/PID,ͬ־,20uSΪλNAKʱ(0,0xFFFF),0ɹ,ʱ/
                   ӳ,ʵӦ,Ϊṩٶ,ӦöԱӳŻ
* Input          : UINT8 endp_pid ƺ͵ַ  endp_pid: 4λtoken_pid, 4λǶ˵ַ
                   UINT8 tog      ͬ־
                   UINT16 timeout ʱʱ
* Output         : None
* Return         : ERR_USB_UNKNOWN ʱӲ쳣
                   ERR_USB_DISCON  豸Ͽ
                   ERR_USB_CONNECT 豸
                   ERR_SUCCESS     
*******************************************************************************/
UINT8   USBHostTransact( UINT8 endp_pid, UINT8 tog, UINT16 timeout )
{
//  UINT8   TransRetry;
#define TransRetry  UEP0_T_LEN                                     // Լڴ
    UINT8   s, r;
    UINT16  i;
    UH_RX_CTRL = UH_TX_CTRL = tog;
    TransRetry = 0;
    do
    {
        UH_EP_PID = endp_pid;                                       // ָPIDĿĶ˵
        UIF_TRANSFER = 0;                                           // 
//      s = WaitUSB_Interrupt( );
        for ( i = WAIT_USB_TOUT_200US; i != 0 && UIF_TRANSFER == 0; i -- )
        {
            ;
        }
        UH_EP_PID = 0x00;                                           // ֹͣUSB
//      if ( s != ERR_SUCCESS ) return( s );                        // жϳʱ,Ӳ쳣
        if ( UIF_TRANSFER == 0 )
        {
            return( ERR_USB_UNKNOWN );
        }
        if ( UIF_DETECT )                                           // USB豸¼
        {
//          mDelayuS( 200 );                                        // ȴ
            UIF_DETECT = 0;                                         // жϱ־
            s = AnalyzeRootHub( );                                  // ROOT-HUB״̬
            if ( s == ERR_USB_CONNECT )
            {
                FoundNewDev = 1;
            }
#if FOR_ROOT_UDISK_ONLY
            if ( CH559DiskStatus == DISK_DISCONNECT )
            {
                return( ERR_USB_DISCON );                           // USB豸Ͽ¼
            }
            if ( CH559DiskStatus == DISK_CONNECT )
            {
                return( ERR_USB_CONNECT );                          // USB豸¼
            }
#else
            if ( ThisUsbDev.DeviceStatus == ROOT_DEV_DISCONNECT )
            {
                return( ERR_USB_DISCON );                           // USB豸Ͽ¼
            }
            if ( ThisUsbDev.DeviceStatus == ROOT_DEV_CONNECTED )
            {
                return( ERR_USB_CONNECT );                          // USB豸¼
            }
#endif
//          if ( ( USB_HUB_ST & bUHS_H0_ATTACH ) == 0x00 ) return( ERR_USB_DISCON );  // USB豸Ͽ¼
            mDelayuS( 200 );                                        // ȴ
        }
        if ( UIF_TRANSFER )                                         // 
        {
            if ( U_TOG_OK )
            {
                return( ERR_SUCCESS );
            }
            r = USB_INT_ST & MASK_UIS_H_RES;                         // USB豸Ӧ״̬
            if ( r == USB_PID_STALL )
            {
                return( r | ERR_USB_TRANSFER );
            }
            if ( r == USB_PID_NAK )
            {
                if ( timeout == 0 )
                {
                    return( r | ERR_USB_TRANSFER );
                }
                if ( timeout < 0xFFFF )
                {
                    timeout --;
                }
                -- TransRetry;
            }
            else switch ( endp_pid >> 4 )
                {
                case USB_PID_SETUP:
                case USB_PID_OUT:
//                  if ( U_TOG_OK ) return( ERR_SUCCESS );
//                  if ( r == USB_PID_ACK ) return( ERR_SUCCESS );
//                  if ( r == USB_PID_STALL || r == USB_PID_NAK ) return( r | ERR_USB_TRANSFER );
                    if ( r )
                    {
                        return( r | ERR_USB_TRANSFER );                 // ǳʱ/,Ӧ
                    }
                    break;                                              // ʱ
                case USB_PID_IN:
//                  if ( U_TOG_OK ) return( ERR_SUCCESS );
//                  if ( tog ? r == USB_PID_DATA1 : r == USB_PID_DATA0 ) return( ERR_SUCCESS );
//                  if ( r == USB_PID_STALL || r == USB_PID_NAK ) return( r | ERR_USB_TRANSFER );
                    if ( r == USB_PID_DATA0 && r == USB_PID_DATA1 )     // ͬ趪
                    {
                    }                                                   // ͬ
                    else if ( r )
                    {
                        return( r | ERR_USB_TRANSFER );                 // ǳʱ/,Ӧ
                    }
                    break;                                              // ʱ
                default:
                    return( ERR_USB_UNKNOWN );                          // ܵ
                    break;
                }
        }
        else                                                            // ж,Ӧ÷
        {
            USB_INT_FG = 0xFF;                                          /* жϱ־ */
        }
        mDelayuS( 15 );
    }
    while ( ++ TransRetry < 3 );
    return( ERR_USB_TRANSFER );                                         // Ӧʱ
}
/*******************************************************************************
* Function Name  : HostCtrlTransfer
* Description    : ִпƴ,8ֽpSetupReq,DataBufΪѡշ
* Input          : PUINT8X DataBuf Ҫպͷ,ôDataBufָЧڴź
                   PUINT8I RetLen  ʵʳɹշܳȱRetLenָֽڱ
* Output         : None
* Return         : ERR_USB_BUF_OVER IN״̬׶γ
                   ERR_SUCCESS     ݽɹ
                   ״̬
*******************************************************************************/
UINT8   HostCtrlTransfer( PUINT8X DataBuf, PUINT8I RetLen )
{
    UINT8   s, RemLen, RxLen, RxCnt, TxCnt;
    PUINT8X xdata   pBuf;
    PUINT8I xdata   pLen;
    pBuf = DataBuf;
    pLen = RetLen;
    mDelayuS( 200 );
    if ( pLen )
    {
        *pLen = 0;                                                        // ʵʳɹշܳ
    }
    UH_TX_LEN = sizeof( USB_SETUP_REQ );
    s = USBHostTransact( USB_PID_SETUP << 4 | 0x00, 0x00, 200000/20 );    // SETUP׶,200mSʱ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    UH_RX_CTRL = UH_TX_CTRL = bUH_R_TOG | bUH_R_AUTO_TOG | bUH_T_TOG | bUH_T_AUTO_TOG;  // ĬDATA1
    UH_TX_LEN = 0x01;                                                     // Ĭݹ״̬׶ΪIN
    RemLen = pSetupReq -> wLengthH ? 0xFF : pSetupReq -> wLengthL;
    if ( RemLen && pBuf )                                                 // Ҫշ
    {
        if ( pSetupReq -> bRequestType & USB_REQ_TYP_IN )                 // 
        {
            while ( RemLen )
            {
                mDelayuS( 200 );
                s = USBHostTransact( USB_PID_IN << 4 | 0x00, UH_RX_CTRL, 200000/20 );  // IN
                if ( s != ERR_SUCCESS )
                {
                    return( s );
                }
                RxLen = USB_RX_LEN < RemLen ? USB_RX_LEN : RemLen;
                RemLen -= RxLen;
                if ( pLen )
                {
                    *pLen += RxLen;                                        // ʵʳɹշܳ
                }
//              memcpy( pBuf, RxBuffer, RxLen );
//              pBuf += RxLen;
                for ( RxCnt = 0; RxCnt != RxLen; RxCnt ++ )
                {
                    *pBuf = RxBuffer[ RxCnt ];
                    pBuf ++;
                }
                if ( USB_RX_LEN == 0 || ( USB_RX_LEN & ( UsbDevEndp0Size - 1 ) ) )
                {
                    break;                                                 // ̰
                }
            }
            UH_TX_LEN = 0x00;                                              // ״̬׶ΪOUT
        }
        else                                                               // 
        {
            while ( RemLen )
            {
                mDelayuS( 200 );
                UH_TX_LEN = RemLen >= UsbDevEndp0Size ? UsbDevEndp0Size : RemLen;
//              memcpy( TxBuffer, pBuf, UH_TX_LEN );
//              pBuf += UH_TX_LEN;
                for ( TxCnt = 0; TxCnt != UH_TX_LEN; TxCnt ++ )
                {
                    TxBuffer[ TxCnt ] = *pBuf;
                    pBuf ++;
                }
                s = USBHostTransact( USB_PID_OUT << 4 | 0x00, UH_TX_CTRL, 200000/20 );// OUT
                if ( s != ERR_SUCCESS )
                {
                    return( s );
                }
                RemLen -= UH_TX_LEN;
                if ( pLen )
                {
                    *pLen += UH_TX_LEN;                                      // ʵʳɹշܳ
                }
            }
//          UH_TX_LEN = 0x01;                                                // ״̬׶ΪIN
        }
    }
    mDelayuS( 200 );
    s = USBHostTransact( ( UH_TX_LEN ? USB_PID_IN << 4 | 0x00: USB_PID_OUT << 4 | 0x00 ), bUH_R_TOG | bUH_T_TOG, 200000/20 );  // STATUS׶
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    if ( UH_TX_LEN == 0 )
    {
        return( ERR_SUCCESS );                                                // ״̬OUT
    }
    if ( USB_RX_LEN == 0 )
    {
        return( ERR_SUCCESS );                                                // ״̬IN,IN״̬ݳ
    }
    return( ERR_USB_BUF_OVER );                                               // IN״̬׶δ
}
/*******************************************************************************
* Function Name  : CopySetupReqPkg
* Description    : ƿƴ
* Input          : PUINT8C pReqPkt ַ
* Output         : None
* Return         : None
*******************************************************************************/
void    CopySetupReqPkg( PUINT8C pReqPkt )
{
    UINT8   i;
    for ( i = 0; i != sizeof( USB_SETUP_REQ ); i ++ )
    {
        ((PUINT8X)pSetupReq)[ i ] = *pReqPkt;
        pReqPkt ++;
    }
}
/*******************************************************************************
* Function Name  : CtrlGetDeviceDescr
* Description    : ȡ豸,TxBuffer
* Input          : None
* Output         : None
* Return         : ERR_USB_BUF_OVER ȴ
                   ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlGetDeviceDescr( void )
{
    UINT8   s;
    UINT8D  len;
    UsbDevEndp0Size = DEFAULT_ENDP0_SIZE;
    CopySetupReqPkg( SetupGetDevDescr );
    s = HostCtrlTransfer( TxBuffer, &len );                                    // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    UsbDevEndp0Size = ( (PXUSB_DEV_DESCR)TxBuffer ) -> bMaxPacketSize0;        // ˵0,Ǽ򻯴,ӦȻȡǰ8ֽںUsbDevEndp0Sizeټ
    if ( len < ( (PUSB_SETUP_REQ)SetupGetDevDescr ) -> wLengthL )
    {
        return( ERR_USB_BUF_OVER );                                            // ȴ
    }
    return( ERR_SUCCESS );
}
/*******************************************************************************
* Function Name  : CtrlGetConfigDescr
* Description    : ȡ,TxBuffer
* Input          : None
* Output         : None
* Return         : ERR_USB_BUF_OVER ȴ
                   ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlGetConfigDescr( void )
{
    UINT8   s;
    UINT8D  len;
    CopySetupReqPkg( SetupGetCfgDescr );
    s = HostCtrlTransfer( TxBuffer, &len );                                    // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    if ( len < ( (PUSB_SETUP_REQ)SetupGetCfgDescr ) -> wLengthL )
    {
        return( ERR_USB_BUF_OVER );                                             // سȴ
    }
    len = ( (PXUSB_CFG_DESCR)TxBuffer ) -> wTotalLengthL;
    if ( len > MAX_PACKET_SIZE )
    {
        return( ERR_USB_BUF_OVER );                                             // سȴ
    }
    CopySetupReqPkg( SetupGetCfgDescr );
    pSetupReq -> wLengthL = len;                                                // ܳ
    s = HostCtrlTransfer( TxBuffer, &len );                                     // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    if ( len < ( (PUSB_SETUP_REQ)SetupGetCfgDescr ) -> wLengthL || len < ( (PXUSB_CFG_DESCR)TxBuffer ) -> wTotalLengthL )
    {
        return( ERR_USB_BUF_OVER );                                              // ȴ
    }
    return( ERR_SUCCESS );
}
/*******************************************************************************
* Function Name  : CtrlSetUsbAddress
* Description    : USB豸ַ
* Input          : UINT8 addr 豸ַ
* Output         : None
* Return         : ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlSetUsbAddress( UINT8 addr )
{
    UINT8   s;
    CopySetupReqPkg( SetupSetUsbAddr );
    pSetupReq -> wValueL = addr;                                                 // USB豸ַ
    s = HostCtrlTransfer( NULL, NULL );                                          // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    SetHostUsbAddr( addr );                                                      // USBǰUSB豸ַ
    mDelaymS( 10 );                                                              // ȴUSB豸ɲ
    return( ERR_SUCCESS );
}
/*******************************************************************************
* Function Name  : CtrlSetUsbConfig
* Description    : USB豸
* Input          : UINT8 cfg       ֵ
* Output         : None
* Return         : ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlSetUsbConfig( UINT8 cfg )
{
    CopySetupReqPkg( SetupSetUsbConfig );
    pSetupReq -> wValueL = cfg;                                                  // USB豸
    return( HostCtrlTransfer( NULL, NULL ) );                                    // ִпƴ
}
/*******************************************************************************
* Function Name  : CtrlClearEndpStall
* Description    : ˵STALL
* Input          : UINT8 endp       ˵ַ
* Output         : None
* Return         : ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlClearEndpStall( UINT8 endp )
{
    CopySetupReqPkg( SetupClrEndpStall );                                        // ˵Ĵ
    pSetupReq -> wIndexL = endp;                                                 // ˵ַ
    return( HostCtrlTransfer( NULL, NULL ) );                                    /* ִпƴ */
}
/*******************************************************************************
* Function Name  : AnalyzeHidIntEndp
* Description    : зHIDж϶˵ĵַ
* Input          : PUINT8X buf       ݻַ
* Output         : None
* Return         : ж϶˵ַ
*******************************************************************************/
UINT8   AnalyzeHidIntEndp( PUINT8X buf )
{
    UINT8   i, s, l;
    s = 0;
    for ( i = 0; i < ( (PXUSB_CFG_DESCR)buf ) -> wTotalLengthL; i += l )         // ж϶˵,ͽӿ
    {
        if ( ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bDescriptorType == USB_DESCR_TYP_ENDP  // Ƕ˵
                && ( ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bmAttributes & USB_ENDP_TYPE_MASK ) == USB_ENDP_TYPE_INTER  // ж϶˵
                && ( ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_DIR_MASK ) )// IN˵
        {
            s = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_ADDR_MASK;// ж϶˵ĵַ
            break;                                                               // ԸҪwMaxPacketSizebInterval
        }
        l = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bLength;                            // ǰ,
        if ( l > 16 )
        {
            break;
        }
    }
    return( s );
}
/*******************************************************************************
* Function Name  : InitRootDevice
* Description    : ʼUSB豸
* Input          : None
* Output         : None
* Return         :
*******************************************************************************/
UINT8   InitRootDevice( void )
{
    UINT8   i, s, cfg, dv_cls, if_cls;
    printf( "Reset host port\n" );
    ResetRootHubPort( );                                                         // ⵽豸,λӦ˿ڵUSB
    for ( i = 0, s = 0; i < 100; i ++ )                                          // ȴUSB豸λ,100mSʱ
    {
        mDelaymS( 1 );
        if ( EnableRootHubPort( ) == ERR_SUCCESS )                               // ʹܶ˿
        {
            i = 0;
            s ++;                                                                // ʱȴUSB豸Ӻȶ
            if ( s > 15 )
            {
                break;                                                           // Ѿȶ15mS
            }
        }
    }
    if ( i )                                                                     // λ豸û
    {
        DisableRootHubPort( );
        printf( "Disable host port because of disconnect\n" );
        return( ERR_USB_DISCON );
    }
    SetUsbSpeed( ThisUsbDev.DeviceSpeed );                                       // õǰUSBٶ
    printf( "GetDevDescr: " );    
	s = CtrlGetDeviceDescr( );                                                   // ȡ豸
    if ( s == ERR_SUCCESS )
    {
        for ( i = 0; i < ( (PUSB_SETUP_REQ)SetupGetDevDescr ) -> wLengthL; i ++ )
        {
            printf( "x%02X ", (UINT16)( TxBuffer[i] ) );
        }
        printf( "\n" );                                                           // ʾ
        dv_cls = ( (PXUSB_DEV_DESCR)TxBuffer ) -> bDeviceClass;                   // 豸
        s = CtrlSetUsbAddress( ( (PUSB_SETUP_REQ)SetupSetUsbAddr ) -> wValueL );  // USB豸ַ
        if ( s == ERR_SUCCESS )
        {
//          ThisUsbDev.DeviceAddress = ( (PUSB_SETUP_REQ)SetupSetUsbAddr ) -> wValueL;// USBַ
            printf( "GetCfgDescr: " );
            s = CtrlGetConfigDescr( );                                            // ȡ
            if ( s == ERR_SUCCESS )
            {
                cfg = ( (PXUSB_CFG_DESCR)TxBuffer ) -> bConfigurationValue;
                for ( i = 0; i < ( (PXUSB_CFG_DESCR)TxBuffer ) -> wTotalLengthL; i ++ )
                {
                    printf( "x%02X ", (UINT16)( TxBuffer[i] ) );
                }
                printf("\n");
                /* ,ȡ˵/˵ַ/˵С,±endp_addrendp_size */
                if_cls = ( (PXUSB_CFG_DESCR_LONG)TxBuffer ) -> itf_descr.bInterfaceClass;  // ӿ
                if ( dv_cls == 0x00 && if_cls == USB_DEV_CLASS_STORAGE )          // USB洢豸,ȷU
                {
#if FOR_ROOT_UDISK_ONLY
                    CH559DiskStatus = DISK_USB_ADDR;
                    return( ERR_SUCCESS );
                }
                else
                {
                    return( ERR_USB_UNSUPPORT );
                }
#else
                    s = CtrlSetUsbConfig( cfg );                                   // USB豸
                    if ( s == ERR_SUCCESS )
                    {
                        ThisUsbDev.DeviceStatus = ROOT_DEV_SUCCESS;
                        ThisUsbDev.DeviceType = USB_DEV_CLASS_STORAGE;
                        printf( "USB-Disk Ready\n" );
                        SetUsbSpeed( 1 );                                          // ĬΪȫ
                        return( ERR_SUCCESS );
                    }
                }
                else if ( dv_cls == 0x00 && if_cls == USB_DEV_CLASS_PRINTER && ( (PXUSB_CFG_DESCR_LONG)TxBuffer ) -> itf_descr.bInterfaceSubClass == 0x01 )    // Ǵӡ豸
                {
                    s = CtrlSetUsbConfig( cfg );                                   // USB豸
                    if ( s == ERR_SUCCESS )
                    {
                        //豣˵ϢԱUSB
                        ThisUsbDev.DeviceStatus = ROOT_DEV_SUCCESS;
                        ThisUsbDev.DeviceType = USB_DEV_CLASS_PRINTER;
                        printf( "USB-Print Ready\n" );
                        SetUsbSpeed( 1 );                                          // ĬΪȫ
                        return( ERR_SUCCESS );
                    }
                }
                else if ( dv_cls == 0x00 && if_cls == USB_DEV_CLASS_HID && ( (PXUSB_CFG_DESCR_LONG)TxBuffer ) -> itf_descr.bInterfaceSubClass <= 0x01 )    // HID豸,/
                {
                    s = AnalyzeHidIntEndp( TxBuffer );                              // зHIDж϶˵ĵַ
                    ThisUsbDev.GpVar = s & USB_ENDP_ADDR_MASK ;                     // ж϶˵ĵַ,λ7ͬ־λ,0
                    if_cls = ( (PXUSB_CFG_DESCR_LONG)TxBuffer ) -> itf_descr.bInterfaceProtocol;
                    s = CtrlSetUsbConfig( cfg );                                    // USB豸
                    if ( s == ERR_SUCCESS )
                    {
//                      Set_Idle( );
                        //豣˵ϢԱUSB
                        ThisUsbDev.DeviceStatus = ROOT_DEV_SUCCESS;
                        if ( if_cls == 1 )
                        {
                            ThisUsbDev.DeviceType = DEV_TYPE_KEYBOARD;
                            //һʼ,豸ָʾLED
                            printf( "USB-Keyboard Ready\n" );
                            SetUsbSpeed( 1 );                                       // ĬΪȫ
                            return( ERR_SUCCESS );
                        }
                        else if ( if_cls == 2 )
                        {
                            ThisUsbDev.DeviceType = DEV_TYPE_MOUSE;
                            //ΪԺѯ״̬,Ӧ÷,ȡж϶˿ڵĵַ,ȵϢ
                            printf( "USB-Mouse Ready\n" );
                            SetUsbSpeed( 1 );                                       // ĬΪȫ
                            return( ERR_SUCCESS );
                        }
                        s = ERR_USB_UNSUPPORT;
                    }
                }
                else                                                                // Խһ
                {
                    s = CtrlSetUsbConfig( cfg );                                    // USB豸
                    if ( s == ERR_SUCCESS )
                    {
                        //豣˵ϢԱUSB
                        ThisUsbDev.DeviceStatus = ROOT_DEV_SUCCESS;
                        ThisUsbDev.DeviceStatus = dv_cls ? dv_cls : if_cls;
                        SetUsbSpeed( 1 );                                           // ĬΪȫ
                        return( ERR_SUCCESS );                                      /* δ֪豸ʼɹ */
                    }
                }
#endif
            }
        }
    }
    printf( "InitRootDev Err = %02X\n", (UINT16)s );
#if FOR_ROOT_UDISK_ONLY
    CH559DiskStatus = DISK_CONNECT;
#else
    ThisUsbDev.DeviceStatus = ROOT_DEV_FAILED;
#endif
    SetUsbSpeed( 1 );                                                                // ĬΪȫ
    return( s );
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void    mInitSTDIO( void )
{
//  SCON = 0x50;
    SM0 = 0;
    SM1 = 1;
    SM2 = 0;
    REN = 1;
    PCON |= SMOD;
    TMOD = TMOD & ~ bT1_GATE & ~ bT1_CT & ~ MASK_T1_MOD | bT1_M1;                    // 0X20
    T2MOD = T2MOD | bTMR_CLK | bT1_CLK;                                              // *12
    TH1 = 0-13;//0xF3;                                                               /* 12MHz, 4800bps*12=57600bps */
    TR1 = 1;
    TI = 1;
}
/*******************************************************************************
* Function Name  : InitUSB_Host
* Description    : ʼUSB
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void    InitUSB_Host( void )
{
    IE_USB = 0;
//  LED_CFG = 1;
//  LED_RUN = 0;
    USB_CTRL = bUC_HOST_MODE;                                                        // 趨ģʽ
    USB_DEV_AD = 0x00;
    UH_EP_MOD = bUH_EP_TX_EN | bUH_EP_RX_EN ;
    UH_RX_DMA = RxBuffer;
    UH_TX_DMA = TxBuffer;
    UH_RX_CTRL = 0x00;
    UH_TX_CTRL = 0x00;
    USB_CTRL = bUC_HOST_MODE | bUC_INT_BUSY | bUC_DMA_EN;                            // USBDMA,жϱ־δǰԶͣ
//  UHUB0_CTRL = 0x00;
//  UHUB1_CTRL = 0x00;
    UH_SETUP = bUH_SOF_EN;
    USB_INT_FG = 0xFF;                                                               // жϱ־
    DisableRootHubPort( );                                                           // 
    USB_INT_EN = bUIE_TRANSFER | bUIE_DETECT;
//  IE_USB = 1;                                                                      // ѯʽ
}
UINT8X  buf[ 100 ];
/*******************************************************************************
* Function Name  : UDISK_demo
* Description    : U̲̣USB߸λUӡȡ豸USBַѡĻȡ֮󵽴˴CH559ӳɺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8   UDISK_demo( void )
{
    UINT8   i, s;
    printf( "Start UDISK_demo @CH559UFI library\n" );
    CH559DiskStatus = DISK_USB_ADDR;
    for ( i = 0; i != 10; i ++ )
    {
        printf( "Wait DiskReady\n" );
        s = CH559DiskReady( );
        if ( s == ERR_SUCCESS )
        {
            break;
        }
        mDelaymS( 50 );
    }
    if ( CH559DiskStatus >= DISK_MOUNTED )                                            /* U׼ */
    {
        printf( "FileCreate\n" );
        strcpy( mCmdParam.Open.mPathName, "/MY_ADC.TXT" );                            /* ļ,ļڸĿ¼ */
        s = CH559FileCreate( );                                                       /* ½ļ,ļѾɾ½ */
        if ( s == ERR_SUCCESS )
        {
            printf( "ByteWrite\n" );
            i = sprintf( buf, "ADC=%d,ʱ=%u\xd\xa", ADC_FIFO, (TH1<<8)|TL1 );/* ADCʾ */
            mCmdParam.ByteWrite.mByteCount = i;                                       /* ָдֽ */
            mCmdParam.ByteWrite.mByteBuffer = buf;                                    /* ָ򻺳 */
            s = CH559ByteWrite( );                                                    /* ֽΪλļд */
            if ( s == ERR_SUCCESS )
            {
                /* Ĭ,ֽmCmdParam.ByteWrite.mByteCountΪ0ôCH559ByteWriteֻдݶ޸ļ,
                   ʱ䲻дӦøļ,ֹͻȻϵǰдļȲ,
                   Ҫдݺ޸/ļ,ôֽmCmdParam.ByteWrite.mByteCountΪ0CH559ByteWriteǿиļ,
                   ȷͻȻϵߺܿݲд򲻱ظļ,ٶȲU(Uڲڴ,Ƶд) */
                /*              mCmdParam.ByteWrite.mByteCount = 0;  ָд0ֽ,ˢļĳ
                                CH559ByteWrite( );  ֽΪλļд,Ϊ0ֽд,ֻڸļĳ,׶дݺ,ְ취ļ */
                printf( "FileClose with updating size\n" );
                mCmdParam.Close.mUpdateLen = 1;                                        /* Զļ,ֽΪλдļ,óرļԱԶļ */
                s = CH559FileClose( );                                                 /* رļ */
                if ( s == ERR_SUCCESS )
                {
                    printf( "File Create..Write..Close OK\n" );
                }
                else
                {
                    printf( "ErrorClose=%02X\n", (UINT16)s );
                }
            }
            else
            {
                printf( "FileClose\n" );
                printf( "ErrorWrite=%02X\n", (UINT16)s );
                mCmdParam.Close.mUpdateLen = 0;                                         /* Զļ */
                CH559FileClose( );                                                      /* رļ */
            }
        }
        else
        {
            printf( "ErrorCreate=%02X\n", (UINT16)s );
        }
    }
    else
    {
        printf( "Disk not ready=%02X\n", (UINT16)s );
    }
    printf( "Finished UDISK_demo\n" );
    return( s );
}
main( )
{
    UINT8   i, s;
#if !FOR_ROOT_UDISK_ONLY
    UINT8   len, endp;
#endif
//  SAFE_MOD = 0x55;
//  SAFE_MOD = 0xAA;
//  CLOCK_CFG |= bOSC_EN_XT;
    mInitSTDIO( );                                                                       /* Ϊüͨڼʾ */
    printf( "Start @ChipID=%02X\n", (UINT16)CHIP_ID );
    InitUSB_Host( );
	CH559LibInit( );                                                                     /* ʼCH559֧Uļ */
	FoundNewDev = 0;
    printf( "Wait Device In\n" );
    while ( 1 )
    {
        s = ERR_SUCCESS;
        if ( UIF_DETECT )                                                                // USBж
        {
            UIF_DETECT = 0;                                                              // жϱ־
            s = AnalyzeRootHub( );                                                       // ROOT-HUB״̬
            if ( s == ERR_USB_CONNECT )
            {
                FoundNewDev = 1;
            }
        }
//      if ( s == ERR_USB_CONNECT ) {
//      }
        if ( FoundNewDev || s == ERR_USB_CONNECT )                                        // µUSB豸
        {
            FoundNewDev = 0;
            mDelaymS( 200 );                                                              // USB豸ղδȶ,ʵȴUSB豸ٺ,ζ
            s = InitRootDevice( );                                                        // ʼUSB豸
            if ( s != ERR_SUCCESS )
            {
                return( s );
            }
        }
//      other work for each device
        mDelaymS( 100 );                                                                   // ģⵥƬ
        if ( RI == 0 )
        {
            continue;
        }
        i = getkey( );
        printf( "%c", (UINT8)i );
#if FOR_ROOT_UDISK_ONLY
        if ( i == 'D' && CH559DiskStatus >= DISK_USB_ADDR )
        {
#else
        if ( i == 'D' && ThisUsbDev.DeviceType == USB_DEV_CLASS_STORAGE && ThisUsbDev.DeviceStatus >= ROOT_DEV_SUCCESS )// ģ,ĳUSB豸в
        {
#endif
            printf( "Access USB-disk\n" );
//          SetHostUsbAddr( ThisUsbDev.DeviceAddress );                                    // USBǰUSB豸ַ
            SetUsbSpeed( ThisUsbDev.DeviceSpeed );                                         // õǰUSBٶ
            // U̽в,CH559UFIHostCtrlTransfer,USBHostTransact
            s = UDISK_demo( );
            if ( s )
            {
                printf( "ErrCode=%02X\n", (UINT16)s );
            }
            SetUsbSpeed( 1 );                                                              // ĬΪȫ
        }
#if !FOR_ROOT_UDISK_ONLY
        else if ( i == 'M' && ThisUsbDev.DeviceType == DEV_TYPE_MOUSE && ThisUsbDev.DeviceStatus >= ROOT_DEV_SUCCESS )// ģ,Ҫ
        {
            printf( "Query Mouse\n" );
//          SetHostUsbAddr( ThisUsbDev.DeviceAddress );                                    // USBǰUSB豸ַ
            SetUsbSpeed( ThisUsbDev.DeviceSpeed );                                         // õǰUSBٶ
//          в
//          s = GetDeviceDescr( );                                                         // ȡ豸
//          if ( s == USB_INT_SUCCESS ) {
//              for ( s = 0; s < ( (PUSB_SETUP_REQ)SetupGetDevDescr ) -> wLengthL; s ++ ) printf( "x%02X ", (UINT16)( TxBuffer[s] ) );
//              printf( "\n" );                                                            // ʾ
//          }
            endp = ThisUsbDev.GpVar;                                                       // ж϶˵ĵַ,λ7ͬ־λ
            if ( endp & USB_ENDP_ADDR_MASK )                                               // ˵Ч
            {
                s = USBHostTransact( USB_PID_IN << 4 | endp & 0x7F, endp & 0x80 ? bUH_R_TOG | bUH_T_TOG : 0, 0 );  // CH559,ȡ,NAK
                if ( s == ERR_SUCCESS )
                {
                    endp ^= 0x80;                                                          // ͬ־ת
                    ThisUsbDev.GpVar = endp;                                               // ͬ־λ
                    len = USB_RX_LEN;                                                      // յݳ
                    if ( len )
                    {
                        printf("Mouse data: ");
                        for ( i = 0; i < len; i ++ )
                        {
                            printf("x%02X ",(UINT16)(RxBuffer[i]) );
                        }
                        printf("\n");
                    }
                }
                else if ( s != ( USB_PID_NAK | ERR_USB_TRANSFER ) )
                {
                    printf("Mouse error %02x\n",(UINT16)s);                                // ǶϿ
                }
            }
            else
            {
                printf("Mouse no interrupt endpoint\n");
            }
            SetUsbSpeed( 1 );                                                               // ĬΪȫ
        }
        else
        {
        }
#endif
    }
}
